<?
		$rubrique = 11;
		$meta_description = "Tutoriel
          sur les DTD (Document Type Definition) d&eacute;finies par la norme
          XML 1.0.";
		$meta_keywords = "cours,
          tutoriel, tutorial,
          XML, DTD, document, type, definition";
		$titre_page = "Tutoriel DTD";
		$urlCss = "./article.css";
		include("$DOCUMENT_ROOT/template/entete.php");
		?>
		  <table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
			<tr>
			  <td>
	<br><h1>Tutoriel DTD</h1><p align="center">
        Par
        <a class="auteur" href="mailto:nicmila@systinet.com">Miloslav
          Nic</a><br>&nbsp;<a class="auteur" href="mailto:elecarre@hotmail.com">Eric Le Carre (traduction)</a><br>&nbsp;</p><p class="synopsis">Les d&eacute;finitions de types de documents (DTD) sont d&eacute;crites dans la
<a href="http://www.w3.org/TR/REC-xml" class="lienArticle">norme XML 1.0</a>. Ce tutoriel pr&eacute;sente les caract&eacute;ristiques de base des DTD &agrave; l'aide de nombreux exemples.<br />
<a href="ftp://TODO" class="lienArticle">Version PDF</a><br />
<a href="ftp://TODO" class="lienArticle">Version HTML/ZIP</a>
</p><br /><a class="summaryIndent0" href="#L1">1. Exemple 1</a><br /><a class="summaryIndent0" href="#L2">2. Exemple 2</a><br /><a class="summaryIndent0" href="#L3">3. Exemple 3</a><br /><a class="summaryIndent0" href="#L4">4. Exemple 4</a><br /><a class="summaryIndent0" href="#L5">5. Exemple 5</a><br /><a class="summaryIndent0" href="#L6">6. Exemple 6</a><br /><a class="summaryIndent0" href="#L7">7. Exemple 7</a><br /><a class="summaryIndent0" href="#L8">8. Exemple 8</a><br /><a class="summaryIndent0" href="#L9">9. Exemple 9</a><br /><a class="summaryIndent0" href="#L10">10. Exemple 10</a><br /><a class="summaryIndent0" href="#L11">11. Exemple 11</a><br /><a class="summaryIndent0" href="#L12">12. Exemple 12</a><br /><a class="summaryIndent0" href="#L13">13. Exemple 13</a><br /><a class="summaryIndent0" href="#L14">14. Exemple 14</a><br /><a class="summaryIndent0" href="#L15">15. Exemple 15</a><br><br><br /><h1 class="TitreSection0"><a name="L1"></a>1. Exemple 1</h1><ul type="">
<div class="paragraph">Un document XML est valide s'il est associ&eacute; &agrave; une d&eacute;finition de type de document et s'il respecte les contraintes qui y sont d&eacute;finies. La d&eacute;finition de type de document doit appara&icirc;tre avant le premier &eacute;l&eacute;ment du document. Le nom qui suit le mot DOCTYPE dans la d&eacute;finition de type de document doit correspondre au nom de l'&eacute;l&eacute;ment racine. </div><br>
<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT tutorial (#PCDATA)&gt;</div></pre>
<div class="paragraph">Un document ne peut comporter qu'un seul &eacute;l&eacute;ment racine tutorial qui peut contenir du texte </div><br>
</li>


<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">tutorial</span>&gt;Ceci est un document XML&lt;/<span class="xml_balise">tutorial</span>&gt;</div></pre>
<div class="paragraph">Document valide comportant du texte</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">tutorial</span>/&gt;</div></pre>

<div class="paragraph">Ce document est &eacute;galement valide</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">text</span>&gt;Ceci est un document XML&lt;/<span class="xml_balise">text</span>&gt;</div></pre>

<div class="paragraph">L'&eacute;l&eacute;ment racine n'est pas conforme &agrave; la DTD sp&eacute;cifi&eacute;e</div><br>
</li>

</ul><br /><h1 class="TitreSection0"><a name="L2"></a>2. Exemple 2</h1><ul type="">
<div class="paragraph">Un type d'&eacute;l&eacute;ment a un contenu d'&eacute;l&eacute;ment lorsque les &eacute;l&eacute;ments de ce type ne doivent comporter que des &eacute;l&eacute;ment fils (aucune donn&eacute;e caract&egrave;re), &eacute;ventuellement s&eacute;par&eacute;s par des espaces.</div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT XXX (AAA , BBB)&gt;
&lt;!ELEMENT AAA (#PCDATA)&gt;
&lt;!ELEMENT BBB (#PCDATA)&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment racine XXX doit pr&eacute;cis&eacute;ment comporter un &eacute;l&eacute;ment AAA, suivi d'un &eacute;l&eacute;ment BBB. Les &eacute;l&eacute;ments AAA et BBB peuvent contenir du texte, mais aucun autre &eacute;l&eacute;ment.</div><br>
</li>


<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
&lt;<span class="xml_balise">AAA</span>&gt;D&eacute;but&lt;/<span class="xml_balise">AAA</span>&gt;
&lt;<span class="xml_balise">BBB</span>&gt;Fin&lt;/<span class="xml_balise">BBB</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Document valide contenant du texte</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Ce document est &eacute;galement valide</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">AAA</span>/&gt; ___ &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment BBB est absent</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment BBB doit suivre l'&eacute;l&eacute;ment AAA</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;<span class="xml_balise">BBB</span>/&gt;  &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment racine XXX ne peut contenir qu'un &eacute;l&eacute;ment BBB</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; El&eacute;ments : &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">BBB</span>/&gt;   &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment racine XXX ne doit contenir aucun texte</div><br>
</li>

</ul><br /><h1 class="TitreSection0"><a name="L3"></a>3. Exemple 3</h1><ul type="">
<div class="paragraph">Dans une DTD, si un nom d'&eacute;l&eacute;ment est suivi d'un ast&eacute;risque  [*], cet &eacute;l&eacute;ment peut figurer z&eacute;ro, une ou plusieurs fois.</div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT XXX (AAA* , BBB)&gt;
&lt;!ELEMENT AAA (#PCDATA)&gt;
&lt;!ELEMENT BBB (#PCDATA)&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment racine XXX peut contenir z&eacute;ro, un ou plusieurs &eacute;l&eacute;ments AAA, suivis pr&eacute;cis&eacute;ment d'un &eacute;l&eacute;ment BBB. L'&eacute;l&eacute;ment BBB doit toujours &ecirc;tre pr&eacute;sent</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Document valide</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Autre document valide. L'&eacute;l&eacute;ment AAA n'est pas obligatoire</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Plusieurs &eacute;l&eacute;ments AAA peuvent figurer dans le document</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; ___ &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment BBB est absent</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment BBB doit suivre l'&eacute;l&eacute;ment AAA</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment AAA ne doit pas suivre l'&eacute;l&eacute;ment BBB</div><br>
</li>

</ul><br /><h1 class="TitreSection0"><a name="L4"></a>4. Exemple 4</h1><ul type="">
<div class="paragraph">Dans une DTD, si un nom d'&eacute;l&eacute;ment est suivi du signe plus [+], cet &eacute;l&eacute;ment peut figurer une ou plusieurs fois.</div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT XXX (AAA+ , BBB)&gt;
&lt;!ELEMENT AAA (#PCDATA)&gt;
&lt;!ELEMENT BBB (#PCDATA)&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment racine XXX doit contenir un ou plusieurs &eacute;l&eacute;ments AAA, suivis pr&eacute;cis&eacute;ment d'un &eacute;l&eacute;ment BBB. L'&eacute;l&eacute;ment BBB doit toujours &ecirc;tre pr&eacute;sent</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Document valide</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Plusieurs &eacute;l&eacute;ments AAA peuvent figurer dans le document</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; ___ ___ &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Les &eacute;l&eacute;ments AAA et BBB sont absents</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; ___&lt;<span class="xml_balise">BBB</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Au moins un &eacute;l&eacute;ment AAA doit &ecirc;tre pr&eacute;sent</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment BBB doit suivre l'&eacute;l&eacute;ment AAA</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment AAA ne doit pas suivre l'&eacute;l&eacute;ment  BBB</div><br>
</li>

</ul><br /><h1 class="TitreSection0"><a name="L5"></a>5. Exemple 5</h1><ul type="">
<div class="paragraph">Dans une DTD, si un nom d'&eacute;l&eacute;ment est suivi d'un point d'interrogation [?], cet &eacute;l&eacute;ment peut figurer z&eacute;ro ou une fois.</div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT XXX (AAA? , BBB)&gt;
&lt;!ELEMENT AAA (#PCDATA)&gt;
&lt;!ELEMENT BBB (#PCDATA)&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment racine XXX peut contenir un &eacute;l&eacute;ment AAA, suivi pr&eacute;cis&eacute;ment d'un &eacute;l&eacute;ment BBB. L'&eacute;l&eacute;ment BBB doit toujours &ecirc;tre pr&eacute;sent.</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Document valide</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;  &lt;<span class="xml_balise">BBB</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment AAA n'est pas obligatoire</div><br>
</li>


<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; ___ &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment BBB est absent</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Un &eacute;l&eacute;ment AAA au maximum peut figurer dans le document</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt; &lt;<span class="xml_balise">BBB</span>/&gt; &lt;<span class="xml_balise">AAA</span>/&gt; &lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment BBB doit suivre l'&eacute;l&eacute;ment AAA</div><br>
</li>

</ul><br /><h1 class="TitreSection0"><a name="L6"></a>6. Exemple 6</h1><ul type="">
<div class="paragraph">Cet exemple utilise une combinaison de [ + * ?]</div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT XXX (AAA? , BBB+)&gt;
&lt;!ELEMENT AAA (CCC? , DDD*)&gt;
&lt;!ELEMENT BBB (CCC , DDD)&gt;
&lt;!ELEMENT CCC (#PCDATA)&gt;
&lt;!ELEMENT DDD (#PCDATA)&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment racine XXX peut contenir un &eacute;l&eacute;ment AAA, suivi d'un ou de plusieurs &eacute;l&eacute;ments BBB. L'&eacute;l&eacute;ment AAA peut contenir un &eacute;l&eacute;ment CCC et plusieurs &eacute;l&eacute;ments DDD. L'&eacute;l&eacute;ment BBB doit pr&eacute;cis&eacute;ment contenir un &eacute;l&eacute;ment CCC et un &eacute;l&eacute;ment DDD</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span>&gt;
		&lt;<span class="xml_balise">CCC</span>/&gt;&lt;<span class="xml_balise">DDD</span>/&gt;
	&lt;/<span class="xml_balise">AAA</span>&gt;
	&lt;<span class="xml_balise">BBB</span>&gt;
		&lt;<span class="xml_balise">CCC</span>/&gt;&lt;<span class="xml_balise">DDD</span>/&gt;
	&lt;/<span class="xml_balise">BBB</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Document valide</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span>/&gt;
	&lt;<span class="xml_balise">BBB</span>&gt;
		&lt;<span class="xml_balise">CCC</span>/&gt;&lt;<span class="xml_balise">DDD</span>/&gt;
	&lt;/<span class="xml_balise">BBB</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Les &eacute;l&eacute;ments fils de l'&eacute;l&eacute;ment AAA ne sont pas obligatoires</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">BBB</span>&gt;
		&lt;<span class="xml_balise">CCC</span>/&gt;&lt;<span class="xml_balise">DDD</span>/&gt;
	&lt;/<span class="xml_balise">BBB</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment AAA peut &ecirc;tre omis</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span>/&gt;
	&lt;<span class="xml_balise">BBB</span>/&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment BBB doit contenir les &eacute;l&eacute;ments  CCC et DDD</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span>&gt;
		&lt;<span class="xml_balise">CCC</span>/&gt;&lt;<span class="xml_balise">CCC</span>/&gt;
		&lt;<span class="xml_balise">DDD</span>/&gt;&lt;<span class="xml_balise">DDD</span>/&gt;
	&lt;/<span class="xml_balise">AAA</span>&gt;
	&lt;<span class="xml_balise">BBB</span>&gt;
		&lt;<span class="xml_balise">CCC</span>/&gt;&lt;<span class="xml_balise">DDD</span>/&gt;
	&lt;/<span class="xml_balise">BBB</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment AAA peut contenir un &eacute;l&eacute;ment CCC au maximum</div><br>
</li>

</ul><br /><h1 class="TitreSection0"><a name="L7"></a>7. Exemple 7</h1><ul type="">
<div class="paragraph">Le caract&egrave;re [ | ] vous permet de s&eacute;lectionner un &eacute;l&eacute;ment parmi plusieurs &eacute;l&eacute;ments.</div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT XXX (AAA , BBB)&gt;
&lt;!ELEMENT AAA (CCC , DDD)&gt;
&lt;!ELEMENT BBB (CCC | DDD)&gt;
&lt;!ELEMENT CCC (#PCDATA)&gt;
&lt;!ELEMENT DDD (#PCDATA)&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment racine XXX doit contenir un &eacute;l&eacute;ment AAA, suivi d'un &eacute;l&eacute;ment BBB. L'&eacute;l&eacute;ment AAA doit contenir un &eacute;l&eacute;ment CCC, suivi d'un &eacute;l&eacute;ment DDD. L'&eacute;l&eacute;ment BBB doit contenir soit un &eacute;l&eacute;ment CCC, soit un &eacute;l&eacute;ment DDD</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span>&gt;
		&lt;<span class="xml_balise">CCC</span>/&gt; &lt;<span class="xml_balise">DDD</span>/&gt;
	&lt;/<span class="xml_balise">AAA</span>&gt;
	&lt;<span class="xml_balise">BBB</span>&gt;
		&lt;<span class="xml_balise">CCC</span>/&gt;
	&lt;/<span class="xml_balise">BBB</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Document valide</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span>&gt;
		&lt;<span class="xml_balise">CCC</span>/&gt; &lt;<span class="xml_balise">DDD</span>/&gt;
	&lt;/<span class="xml_balise">AAA</span>&gt;
	&lt;<span class="xml_balise">BBB</span>&gt;
		&lt;<span class="xml_balise">DDD</span>/&gt;
	&lt;/<span class="xml_balise">BBB</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Autre document valide</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span>&gt;
		&lt;<span class="xml_balise">CCC</span>/&gt; &lt;<span class="xml_balise">DDD</span>/&gt;
	&lt;/<span class="xml_balise">AAA</span>&gt;
	&lt;<span class="xml_balise">BBB</span>&gt;
		&lt;<span class="xml_balise">CCC</span>/&gt; &lt;<span class="xml_balise">DDD</span>/&gt;
	&lt;/<span class="xml_balise">BBB</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment BBB peut contenir soit un &eacute;l&eacute;ment CCC, soit un &eacute;l&eacute;ment DDD, mais pas les deux &agrave; la fois</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span>&gt;
		&lt;<span class="xml_balise">CCC</span>/&gt; &lt;<span class="xml_balise">DDD</span>/&gt;
	&lt;/<span class="xml_balise">AAA</span>&gt;
	&lt;<span class="xml_balise">BBB</span>&gt;
		&lt;<span class="xml_balise">DDD</span>/&gt;  &lt;<span class="xml_balise">CCC</span>/&gt;
	&lt;/<span class="xml_balise">BBB</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment BBB peut contenir soit un &eacute;l&eacute;ment CCC, soit un &eacute;l&eacute;ment DDD, mais pas les deux &agrave; la fois</div><br>
</li>


</ul><br /><h1 class="TitreSection0"><a name="L8"></a>8. Exemple 8</h1><ul type="">
<div class="paragraph">Du texte peut &ecirc;tre ins&eacute;r&eacute; avec les &eacute;l&eacute;ments.</div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT XXX (AAA+ , BBB+)&gt;
&lt;!ELEMENT AAA (BBB | CCC )&gt;
&lt;!ELEMENT BBB (#PCDATA | CCC )*&gt;
&lt;!ELEMENT CCC (#PCDATA)&gt;</div></pre>
<div class="paragraph"> L'&eacute;l&eacute;ment AAA peut contenir soit un &eacute;l&eacute;ment BBB, soit un &eacute;l&eacute;ment CCC. En revanche, l'&eacute;l&eacute;ment BBB peut contenir n'importe quelle combinaison de texte et d'&eacute;l&eacute;ments CCC.</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span>&gt;
		&lt;<span class="xml_balise">CCC</span>&gt;Pr&eacute;cis&eacute;ment un &eacute;l&eacute;ment.&lt;/<span class="xml_balise">CCC</span>&gt; 
	&lt;/<span class="xml_balise">AAA</span>&gt;
	&lt;<span class="xml_balise">AAA</span>&gt;
		&lt;<span class="xml_balise">BBB</span>&gt;
			&lt;<span class="xml_balise">CCC</span>/&gt;
			&lt;<span class="xml_balise">CCC</span>/&gt;
			&lt;<span class="xml_balise">CCC</span>/&gt;
		&lt;/<span class="xml_balise">BBB</span>&gt;
	&lt;/<span class="xml_balise">AAA</span>&gt;
	&lt;<span class="xml_balise">BBB</span>/&gt;
	&lt;<span class="xml_balise">BBB</span>&gt;
		Voici &lt;<span class="xml_balise">CCC</span>/&gt; une combinaison &lt;<span class="xml_balise">CCC</span>/&gt; d'&lt;<span class="xml_balise">CCC</span>&gt;&eacute;l&eacute;ments CCC &lt;/<span class="xml_balise">CCC</span>&gt; et de texte &lt;<span class="xml_balise">CCC</span>/&gt;. 
	&lt;/<span class="xml_balise">BBB</span>&gt;
	&lt;<span class="xml_balise">BBB</span>&gt;
		Uniquement du texte. 
	&lt;/<span class="xml_balise">BBB</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Document valide exploitant plusieurs possibilit&eacute;s</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span>&gt;
		El&eacute;ment : &lt;<span class="xml_balise">CCC</span>/&gt;
	&lt;/<span class="xml_balise">AAA</span>&gt;
	&lt;<span class="xml_balise">BBB</span>&gt;
		El&eacute;ment : &lt;<span class="xml_balise">CCC</span>/&gt; 
	&lt;/<span class="xml_balise">BBB</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment AAA ne peut pas contenir de texte</div><br>
</li>
</ul><br /><h1 class="TitreSection0"><a name="L9"></a>9. Exemple 9</h1><ul type="">
<div class="paragraph">Les attributs servent &agrave; associer des paires Nom-valeur aux &eacute;l&eacute;ments. Les sp&eacute;cifications d'attributs ne peuvent figurer que dans les balises de d&eacute;but et les balises d'&eacute;l&eacute;ments vides. La d&eacute;claration commence par ATTLIST, suivent apr&egrave;s le nom de l'&eacute;l&eacute;ment auquel les attributs sont rattach&eacute;s et, enfin, la d&eacute;finition des attributs individuels. </div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT attributes (#PCDATA)&gt;
&lt;!ATTLIST attributes 
		aaa CDATA #REQUIRED
		bbb CDATA #IMPLIED&gt;</div></pre>
<div class="paragraph">Un attribut de type CDATA peut contenir n'importe quel caract&egrave;re, s'il respecte les contraintes de forme. L'attribut obligatoire doit toujours &ecirc;tre pr&eacute;sent, tandis que l'attribut implicite est facultatif.</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">attributes</span> aaa=<span class="xml_ch">"#d1"</span> bbb=<span class="xml_ch">"*~*"</span>&gt;
	Texte
&lt;/<span class="xml_balise">attributes</span>&gt;</div></pre>
<div class="paragraph">L'attribut de type CDATA peut contenir n'importe quel caract&egrave;re respectant les contraintes de forme</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">attributes</span> bbb=<span class="xml_ch">"$25"</span> aaa=<span class="xml_ch">"13%"</span>&gt;
	Texte
&lt;/<span class="xml_balise">attributes</span>&gt;</div></pre>
<div class="paragraph">L'ordre des attributs n'a pas d'importance</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">attributes</span> aaa=<span class="xml_ch">"#d1"</span> /&gt;</div></pre>
<div class="paragraph">L'attribut bbb peut &ecirc;tre omis, car il est implicite</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">attributes</span> ___ bbb=<span class="xml_ch">"X24"</span>/&gt;</div></pre>
<div class="paragraph">L'attribut aaa &eacute;tant obligatoire, il doit donc &ecirc;tre toujours pr&eacute;sent</div><br>
</li>



</ul><br /><h1 class="TitreSection0"><a name="L10"></a>10. Exemple 10</h1><ul type="">
<div class="paragraph">Un attribut de type CDATA peut contenir n'importe quel caract&egrave;re, s'il respecte les contraintes de forme. Les attributs de type NMTOKEN ne peuvent contenir que des lettres, des chiffres, un point [ . ] , un tiret [ - ], un trait de soulignement [ _ ] et un deux-points  [ : ]. Les attributs de type NMTOKENS peuvent contenir les m&ecirc;mes caract&egrave;res que les attributs de type NMTOKEN, plus des espaces blancs. Par espace blanc, on entend un ou plusieurs espaces, retours chariot, sauts de ligne ou tabulations. </div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT attributes (#PCDATA)&gt;
&lt;!ATTLIST attributes 
		aaa CDATA #IMPLIED
		bbb NMTOKEN #REQUIRED
		ccc NMTOKENS #REQUIRED&gt;</div></pre>
<div class="paragraph">Les attributs bbb et ccc doivent toujours &ecirc;tre pr&eacute;sents, tandis que l'attribut aaa est facultatif</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">attributes</span> aaa=<span class="xml_ch">"#d1"</span> bbb=<span class="xml_ch">"a1:12"</span> ccc=<span class="xml_ch">" 3.4 div	 -4"</span>/&gt;</div></pre>
<div class="paragraph">Tous les attributs obligatoires sont pr&eacute;sents et le type de leur valeur est correct</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">attributes</span> bbb=<span class="xml_ch">"a1:12"</span> 
ccc="3.4
div 
-4"/&gt;</div></pre>
<div class="paragraph">Tous les attributs obligatoires sont pr&eacute;sents et le type de leur valeur est correct</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">attributes</span> aaa=<span class="xml_ch">"#d1"</span> bbb=<span class="xml_ch">"#d1"</span> ccc=<span class="xml_ch">"#d1"</span>/&gt;</div></pre>
<div class="paragraph">Le caract&egrave;re # est interdit dans les attributs de type NMTOKEN et NMTOKENS</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">attributes</span> bbb=<span class="xml_ch">"A B C"</span> ccc=<span class="xml_ch">"A 	B 	C"</span>/&gt;</div></pre>
<div class="paragraph">L'espace est interdit dans les attributs de type NMTOKEN</div><br>
</li>

</ul><br /><h1 class="TitreSection0"><a name="L11"></a>11. Exemple 11</h1><ul type="">
<div class="paragraph">La valeur d'un attribut de type ID ne peut &ecirc;tre constitu&eacute;e que de caract&egrave;res autoris&eacute;s pour le type NMTOKEN et doit commencer par une lettre. Un type d'&eacute;l&eacute;ment ne peut pas avoir plusieurs attributs de type ID. La valeur d'un attribut de type ID doit &ecirc;tre unique par rapport &agrave; l'ensemble des valeurs de tous les attributs de type ID.</div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT XXX (AAA+ , BBB+ , CCC+)&gt;
&lt;!ELEMENT AAA (#PCDATA)&gt;
&lt;!ELEMENT BBB (#PCDATA)&gt;
&lt;!ELEMENT CCC (#PCDATA)&gt;
&lt;!ATTLIST AAA 
		id ID #REQUIRED&gt;
&lt;!ATTLIST BBB 
		code ID #IMPLIED
		list NMTOKEN #IMPLIED&gt;		
&lt;!ATTLIST CCC 
		X ID #REQUIRED
		Y NMTOKEN #IMPLIED&gt;</div></pre>
<div class="paragraph">Les attributs id, code et X identifient de mani&egrave;re unique leur &eacute;l&eacute;ment</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> id=<span class="xml_ch">"a1"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> id=<span class="xml_ch">"a2"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> id=<span class="xml_ch">"a3"</span>/&gt;
	&lt;<span class="xml_balise">BBB</span> code=<span class="xml_ch">"QWQ-123-14-6"</span> list=<span class="xml_ch">"14:5"</span>/&gt;
	&lt;<span class="xml_balise">CCC</span> X=<span class="xml_ch">"zero"</span> Y=<span class="xml_ch">"16"</span> /&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Toutes les valeurs ID sont uniques</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> id=<span class="xml_ch">"L12"</span>/&gt;
	&lt;<span class="xml_balise">BBB</span> code=<span class="xml_ch">"QW"</span> list=<span class="xml_ch">"L12"</span>/&gt;
	&lt;<span class="xml_balise">CCC</span> X=<span class="xml_ch">"x-0"</span> Y=<span class="xml_ch">"QW"</span> /&gt;
	&lt;<span class="xml_balise">CCC</span> X=<span class="xml_ch">"x-1"</span> Y=<span class="xml_ch">"QW"</span> /&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Les attributs list et Y sont de type NMTOKEN, et pas de type ID. Ils peuvent donc avoir la m&ecirc;me valeur que les attributs ID ou la m&ecirc;me valeur dans plusieurs &eacute;l&eacute;ments</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> id=<span class="xml_ch">"L12"</span>/&gt;
	&lt;<span class="xml_balise">BBB</span> code=<span class="xml_ch">"#QW"</span> list=<span class="xml_ch">"L12"</span>/&gt;
	&lt;<span class="xml_balise">CCC</span> X=<span class="xml_ch">"12"</span> Y=<span class="xml_ch">"QW"</span> /&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'attribut ID ne doit pas commencer par un nombre ou contenir un caract&egrave;re interdit pour le type NMTOKEN</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> id=<span class="xml_ch">"L12"</span>/&gt;
	&lt;<span class="xml_balise">BBB</span> code=<span class="xml_ch">"QW"</span> list=<span class="xml_ch">"L12"</span>/&gt;
	&lt;<span class="xml_balise">CCC</span> X=<span class="xml_ch">"ZA"</span> Y=<span class="xml_ch">"QW"</span> /&gt;
	&lt;<span class="xml_balise">CCC</span> X=<span class="xml_ch">"ZA"</span> Y=<span class="xml_ch">"QW"</span> /&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'attribut ID doit comporter une valeur unique</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> id=<span class="xml_ch">"L12"</span>/&gt;
	&lt;<span class="xml_balise">BBB</span> code=<span class="xml_ch">"QW"</span> list=<span class="xml_ch">"L12"</span>/&gt;
	&lt;<span class="xml_balise">CCC</span> X=<span class="xml_ch">"L12"</span> Y=<span class="xml_ch">"QW"</span> /&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'attribut ID doit comporter une valeur unique. Les attributs id et X sont tous les deux de type ID</div><br>
</li>

</ul><br /><h1 class="TitreSection0"><a name="L12"></a>12. Exemple 12</h1><ul type="">
<div class="paragraph">La valeur de l'attribut IDREF doit correspondre &agrave; celle de l'un des attributs ID pr&eacute;sents dans le document. La valeur de l'attribut IDREFS peut contenir plusieurs r&eacute;f&eacute;rences &agrave; des &eacute;l&eacute;ments comportant un attribut ID en les s&eacute;parant par des espaces blancs.</div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT XXX (AAA+ , BBB+, CCC+, DDD+)&gt;
&lt;!ELEMENT AAA (#PCDATA)&gt;
&lt;!ELEMENT BBB (#PCDATA)&gt;
&lt;!ELEMENT CCC (#PCDATA)&gt;
&lt;!ELEMENT DDD (#PCDATA)&gt;
&lt;!ATTLIST AAA 
		mark ID #REQUIRED&gt;
&lt;!ATTLIST BBB 
		id ID #REQUIRED&gt;		
&lt;!ATTLIST CCC 
		ref IDREF #REQUIRED&gt;
&lt;!ATTLIST DDD 
		ref IDREFS #REQUIRED&gt;</div></pre>
<div class="paragraph">Les attributs id et mark identifient de mani&egrave;re unique leur &eacute;l&eacute;ment. Les attributs ref font r&eacute;f&eacute;rence &agrave; ces &eacute;l&eacute;ments</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> mark=<span class="xml_ch">"a1"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> mark=<span class="xml_ch">"a2"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> mark=<span class="xml_ch">"a3"</span>/&gt;
	&lt;<span class="xml_balise">BBB</span> id=<span class="xml_ch">"b001"</span> /&gt;
	&lt;<span class="xml_balise">CCC</span> ref=<span class="xml_ch">"a3"</span> /&gt;
	&lt;<span class="xml_balise">DDD</span> ref=<span class="xml_ch">"a1 b001 a2"</span> /&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Toutes les valeurs des attributs ID sont uniques et tous les attributs IDREF et IDREFS pointent vers des &eacute;l&eacute;ments comportant des attributs ID appropri&eacute;s</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> mark=<span class="xml_ch">"a1"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> mark=<span class="xml_ch">"a2"</span>/&gt;	
	&lt;<span class="xml_balise">BBB</span> id=<span class="xml_ch">"b01"</span> /&gt;
	&lt;<span class="xml_balise">CCC</span> ref=<span class="xml_ch">"a3"</span> /&gt;
	&lt;<span class="xml_balise">DDD</span> ref=<span class="xml_ch">"a1 b001 a2"</span> /&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Il n'y a aucun attribut ID ayant a3 ou b001 comme valeur</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> mark=<span class="xml_ch">"a1"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> mark=<span class="xml_ch">"a2"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> mark=<span class="xml_ch">"a3"</span>/&gt;
	&lt;<span class="xml_balise">BBB</span> id=<span class="xml_ch">"b001"</span> /&gt;
	&lt;<span class="xml_balise">CCC</span> ref=<span class="xml_ch">"a1 b001 a2"</span> /&gt;
	&lt;<span class="xml_balise">DDD</span> ref=<span class="xml_ch">"a1 b001 a2"</span> /&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'attribut ref de l'&eacute;l&eacute;ment CCC est de type  IDREF. Il ne peut contenir qu'une seule r&eacute;f&eacute;rence</div><br>
</li>

</ul><br /><h1 class="TitreSection0"><a name="L13"></a>13. Exemple 13</h1><ul type="">
<div class="paragraph">Les valeurs d'attributs autoris&eacute;es peuvent &ecirc;tre d&eacute;finies dans la DTD.</div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT XXX (AAA+, BBB+)&gt;
&lt;!ELEMENT AAA (#PCDATA)&gt;
&lt;!ELEMENT BBB (#PCDATA)&gt;
&lt;!ATTLIST AAA 
			vrai ( oui | non ) #REQUIRED&gt;
&lt;!ATTLIST BBB 
	mois (1|2|3|4|5|6|7|8|9|10|11|12) #IMPLIED&gt;</div></pre>
<div class="paragraph">Cette DTD d&eacute;finit pr&eacute;cis&eacute;ment les valeurs autoris&eacute;es</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> vrai=<span class="xml_ch">"oui"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> vrai=<span class="xml_ch">"non"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> vrai=<span class="xml_ch">"oui"</span>/&gt;
	&lt;<span class="xml_balise">BBB</span> mois=<span class="xml_ch">"8"</span> /&gt;
	&lt;<span class="xml_balise">BBB</span> mois=<span class="xml_ch">"2"</span> /&gt;
	&lt;<span class="xml_balise">BBB</span> mois=<span class="xml_ch">"12"</span> /&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Toutes les valeurs sont d&eacute;finies dans la DTD</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> vrai=<span class="xml_ch">"oui"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> vrai=<span class="xml_ch">"non"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> vrai=<span class="xml_ch">"peut-&ecirc;tre"</span>/&gt;
	&lt;<span class="xml_balise">BBB</span> mois=<span class="xml_ch">"8"</span> /&gt;
	&lt;<span class="xml_balise">BBB</span> mois=<span class="xml_ch">"2"</span> /&gt;
	&lt;<span class="xml_balise">BBB</span> mois=<span class="xml_ch">"16"</span> /&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'attribut vrai ne peut pas avoir "peut-&ecirc;tre" comme valeur, et l'attribut mois ne peut pas avoir "16" comme valeur</div><br>
</li>

</ul><br /><h1 class="TitreSection0"><a name="L14"></a>14. Exemple 14</h1><ul type="">
<div class="paragraph">Si un attribut est implicite, une valeur par d&eacute;faut peut &ecirc;tre fournie au cas o&ugrave; l'attribut n'est pas utilis&eacute;.</div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT XXX (AAA+, BBB+)&gt;
&lt;!ELEMENT AAA (#PCDATA)&gt;
&lt;!ELEMENT BBB (#PCDATA)&gt;
&lt;!ATTLIST AAA 
			vrai ( oui | non ) <span class="xml_ch">"oui"</span>&gt;
&lt;!ATTLIST BBB 
	mois NMTOKEN <span class="xml_ch">"1"</span>&gt;</div></pre>
<div class="paragraph">Les deux attributs sont implicites. Leur valeur par d&eacute;faut est d&eacute;finie</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> vrai=<span class="xml_ch">"oui"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> vrai=<span class="xml_ch">"non"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span>/&gt;
	&lt;<span class="xml_balise">BBB</span> mois=<span class="xml_ch">"8"</span> /&gt;
	&lt;<span class="xml_balise">BBB</span> mois=<span class="xml_ch">"2"</span> /&gt;
	&lt;<span class="xml_balise">BBB</span>/&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Les diff&eacute;rentes valeurs de l'attribut vrai sont oui, non et oui. Les diff&eacute;rentes valeurs de l'attribut mois sont 8, 2 et 1</div><br>
</li>

</ul><br /><h1 class="TitreSection0"><a name="L15"></a>15. Exemple 15</h1><ul type="">
<div class="paragraph">Un &eacute;l&eacute;ment peut &ecirc;tre d&eacute;fini comme EMPTY. Dans ce cas, il ne peut contenir que des attributs, mais pas de texte.</div><br>

<li>
<pre class="code"><div class="xml_code">&lt;!ELEMENT XXX (AAA+)&gt;
&lt;!ELEMENT AAA EMPTY&gt;
&lt;!ATTLIST AAA 
		vrai ( oui | non ) <span class="xml_ch">"oui"</span>&gt;</div></pre>
<div class="paragraph">Les &eacute;l&eacute;ments AAA ne peuvent contenir que des attributs, mais pas de texte</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> vrai=<span class="xml_ch">"oui"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> vrai=<span class="xml_ch">"non"</span>&gt;&lt;/<span class="xml_balise">AAA</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">Ces deux formes sont autoris&eacute;es. Dans le second cas, la balise de fin doit imm&eacute;diatement suivre la balise de d&eacute;but</div><br>
</li>

<li>
<pre class="code"><div class="titre_code">Non valide</div><div class="xml_code">&lt;<span class="xml_balise">XXX</span>&gt;
	&lt;<span class="xml_balise">AAA</span> vrai=<span class="xml_ch">"oui"</span>/&gt;
	&lt;<span class="xml_balise">AAA</span> vrai=<span class="xml_ch">"non"</span>&gt;&lt;/<span class="xml_balise">AAA</span>&gt;
	&lt;<span class="xml_balise">AAA</span>&gt;		&lt;/<span class="xml_balise">AAA</span>&gt;
	&lt;<span class="xml_balise">AAA</span>&gt;Salut !&lt;/<span class="xml_balise">AAA</span>&gt;
&lt;/<span class="xml_balise">XXX</span>&gt;</div></pre>
<div class="paragraph">L'&eacute;l&eacute;ment AAA ne doit pas contenir de texte, et la balise de d&eacute;but doit &ecirc;tre imm&eacute;diatement ferm&eacute;e</div><br>
</li>
</ul><br><table class="noteBasPage"></table><hr><div class="licence">
          Copyright (c) 2000 <a href="http://www.systinet.com/" class="lienArticle">Systinet</a><br />

Permission is granted to copy, distribute and/or modify this document under the terms of the GNU Free Documentation License, Version 1.1 or any later version published by the Free Software Foundation; with no Invariant Sections with the no Front-Cover Texts, and with no Back-Cover Texts.
</div>
	  </td>
		</tr>
		   </table>
<?
	include("$DOCUMENT_ROOT/template/pied.php");?>